//+------------------------------------------------------------------+
//|                                                      MA Band.mq4 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

extern int  MAPeriod = 3;

//Declarations
double   MA_top[], MA_bot[], MAT[], MAB[];
int      chart_TF = PERIOD_CURRENT;

//get values of bars
double get_value(char val_type, char MA_type, int i)	//val_type(M = MA, H = High, L = Low, O = Open, C = Close), MA(F = FastMA, S = SlowMA, NULL = Not MA) x = candle number
{
/*	int MA_Period, MA_Shift, MA_Method, MA_Apply;
	
	switch(MA_type)
	{
	   case 'F':
         MA_Period = FastMA_Per;
         MA_Shift = FastMA_Shift;
         MA_Method = FastMA_Method;
         MA_Apply = FastMA_Apply;
	      break;
	   case 'S':
         MA_Period = SlowMA_Per;
         MA_Shift = SlowMA_Shift;
         MA_Method = SlowMA_Method;
         MA_Apply = SlowMA_Apply;
	      break;
	   case 'H':
         MA_Period = HighMA_Per;
         MA_Shift = HighMA_Shift;
         MA_Method = HighMA_Method;
         MA_Apply = HighMA_Apply;
	      break;
	   case 'L':
         MA_Period = LowMA_Per;
         MA_Shift = LowMA_Shift;
         MA_Method = LowMA_Method;
         MA_Apply = LowMA_Apply;
	      break;
   }
*/
	switch(val_type)
	{
/*
		case 'M':
			return iMA(NULL, chart_TF, MA_Period, MA_Shift, MA_Method, MA_Apply, i);
*/
		case 'H':
			return iHigh(NULL, chart_TF, i);
		case 'L':
			return iLow(NULL, chart_TF, i);
		case 'O':
		   return iOpen(NULL, chart_TF, i);
		case 'C':
		   return iClose(NULL, chart_TF, i);
   }
   
   return -1;
}

//Get MA values
void MA_val(int limit)
{
   double valO, valC, tempT, tempB;
   int count = 1;
   
   for(int i = 0; i <= limit; i++)
   {
      tempT = 0;
      tempB = 0;
      
      for(int j = 0; j < MAPeriod; j++)
      {
         valO = get_value('O', NULL, j);
         valC = get_value('C', NULL, j);
         
         if(valO >= valC)
         {
            tempT += valO;
            tempB += valC;
         }
         else
         {
            tempT += valC;
            tempB += valO;
         }
      }

      MA_top[i] = tempT / MAPeriod;
      MA_bot[i] = tempB / MAPeriod;
   }
}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping

      //Draw MA Top
      SetIndexBuffer(0, MA_top);
      SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2, clrAqua);
      SetIndexDrawBegin(0, MAPeriod);
      SetIndexLabel(0, "MA Top");
      
      //Draw MA Bot
      SetIndexBuffer(1, MA_bot);
      SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2, clrDeepPink);
      SetIndexDrawBegin(1, MAPeriod);
      SetIndexLabel(1, "MA Bot");
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
      int counted_bars = IndicatorCounted();
            
      if(counted_bars < 0)
         return -1;
      else
         counted_bars--;
      int uncounted_bars = Bars - counted_bars;

      //Get values for drawing
      MA_val(uncounted_bars);
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
